#define DR_STR_MAX	128

struct mem_scn {
	struct mem_scn	*next;
	int		removable;
	uint64_t	phys_addr;
	char		sysfs_path[DR_PATH_MAX];
};

struct lmb {
	struct lmb	*next;
	struct mem_scn	*mem_scns;
	struct of_node	*of_node;

	uint64_t	address;
	uint32_t	flags;
	uint32_t	lmb_sz;
	int		drc_index;
	int		drc_power;
	
	char		drc_type[DR_STR_MAX];
	char		drc_name[DR_STR_MAX];
	char		ofdt_path[DR_PATH_MAX];
};

struct lmb_list_head {
	struct lmb	*lmbs;
	char		*drconf_buf;
	size_t		drconf_buf_sz;
	int		lmbs_modified;
};

#define LMB_OWNED	0x00000001
#define LMB_ACQUIRED	0x00000002
#define LMB_RELEASED	0x00000004
#define LMB_STATE_SET	0x00000008
#define LMB_REMOVABLE	0x00000010
#define LMB_UNUSABLE	0x00000020

struct drconf_mem {
	uint64_t	address;
	int		drc_index;
	uint32_t	reserved;
	uint32_t	assoc_index;
	uint32_t	flags;
};

#define DRMEM_ASSIGNED		0x00000008
#define DRMEM_DRC_INVALID	0x00000020

#define MEM_PROBE_FILE		"/sys/devices/system/memory/probe"
#define MEM_BLOCK_SIZE_BYTES	"/sys/devices/system/memory/block_size_bytes"
#define DYNAMIC_RECONFIG_MEM	"/proc/device-tree/ibm,dynamic-reconfiguration-memory"

struct lmb_list_head *get_lmbs(void);
void free_lmbs(struct lmb_list_head *);
